<?php

/*************************************************************************
 *
 * CLASS: iSQL
 *
 * Description: SQL container
 *
 *************************************************************************/

class iSQL
{

var $link = false;
var $host, $login, $database;
var $queries = 0;
var $qlog = array();

var $opt_log = false;	// log queries

/*********************************************
 *              iSQL Constructor
 *********************************************/

function iSQL ()
{

global $dbpre;

require ("config.php");

$dbpre = $iOptSQLPrefix;

$this->host	= $iOptSQLHost;
$this->login	= $iOptSQLLogin;
$this->database	= $iOptSQLDb;
// Password NOT stored - security reasons :)

$this->link = @mysql_connect($this->host, $this->login, $iOptSQLPass);

// select the database ONLY if connected
if ($this->link)
{
	if (!@mysql_select_db($this->database))
	{
		die("<B>SQL Engine Initialization Error:</B> Could not select the database.");
	}
}
else
{
	$this->link = false;
	
	die("<B>SQL Engine Initialization Error:</B> Could not connect to host.");
}
}

/*********************************************
 *                   close
 *********************************************/

function close ()
{
if ($this->link)
{
	@mysql_close($this->link);
}
}

/*********************************************
 *                  query
 *********************************************/

function query ($query, $nr=0, $count=0)
{
global $error, $document, $config, $page;

if ($config['debug']=='on')
{
	$itime = new iChrono();
}

// start from $nr and return $count results
	
if ($this->link)
{
	$i = 0;
	$res = array();
	$ri = 0;
	
	// trim extra spaces
	
	$query = trim($query);

	$this->queries++;

	// run the query
	
	$result = @mysql_query($query);

	// queries log selected, so log them
	
	if ($this->opt_log)
	{
		$this->qlog[] = $query;
	}

	// query failed
	
	if (!$result)
	{
		echo "<B>MySQL said</B>: ".mysql_error().".";
		
		return false;
	}

	// return the result in an array if possible
	
	if (eregi ("^((SELECT)|(SHOW)|(DESCRIBE)|(EXPLAIN)|(OPTIMIZE)|(CHECK)|(ANALYZE)|(REPAIR))", $query))
	{
		while ($row = mysql_fetch_assoc($result))
		{
			if ($i>=$nr)
			{
				if ($count==0)
				{
					$res[$ri++]=$row;
				}
				else
				{
					if ($i<($nr+$count))
					{
						$res[$ri++]=$row;
					}
				}
			}
			$i++;
		}
	}
	else
	{
		$res = $result;
	}
	
	@mysql_free_result($result);
	return $res;
}
else
{
	return false;
}
}

/*********************************************
 *                connected
 *********************************************/

function connected ()
{
return ($this->link) ? true : false;
}

/*********************************************
 *               queries_used
 *********************************************/

function queries_used()
{
return $this->queries;
}

/*********************************************
 *              connection_info
 *********************************************/

function connection_info ()
{
return array (

"connected"	=> ($this->link) ? true : false,
"host"		=> $this->host,
"login"		=> $this->login,
"database"	=> $this->database,
"queries"	=> $this->queries

);
}

}
?>